(* http://en.wikipedia.org/wiki/Zigzag 
   http://en.wikipedia.org/wiki/File:JPEG_ZigZag.svg
*)

let node zigzag p = o where
  rec p1 = p when (1 0^63)
  and p2 = p when (0^1 1 0^62)
  and p3 = p when (0^2 1 0^61)
  and p4 = p when (0^3 1 0^60)
  and p5 = p when (0^4 1 0^59)
  and p6 = p when (0^5 1 0^58)
  and p7 = p when (0^6 1 0^57)
  and p8 = p when (0^7 1 0^56)
  and p9 = p when (0^8 1 0^55)

  and p10 = p when (0^9 1 0^54)
  and p11 = p when (0^10 1 0^53)
  and p12 = p when (0^11 1 0^52)
  and p13 = p when (0^12 1 0^51)
  and p14 = p when (0^13 1 0^50)
  and p15 = p when (0^14 1 0^49)
  and p16 = p when (0^15 1 0^48)
  and p17 = p when (0^16 1 0^47)
  and p18 = p when (0^17 1 0^46)
  and p19 = p when (0^18 1 0^45)

  and p20 = p when (0^19 1 0^44)
  and p21 = p when (0^20 1 0^43)
  and p22 = p when (0^21 1 0^42)
  and p23 = p when (0^22 1 0^41)
  and p24 = p when (0^23 1 0^40)
  and p25 = p when (0^24 1 0^39)
  and p26 = p when (0^25 1 0^38)
  and p27 = p when (0^26 1 0^37)
  and p28 = p when (0^27 1 0^36)
  and p29 = p when (0^28 1 0^35)

  and p30 = p when (0^29 1 0^34)
  and p31 = p when (0^30 1 0^33)
  and p32 = p when (0^31 1 0^32)
  and p33 = p when (0^32 1 0^31)
  and p34 = p when (0^33 1 0^30)
  and p35 = p when (0^34 1 0^29)
  and p36 = p when (0^35 1 0^28)
  and p37 = p when (0^36 1 0^27)
  and p38 = p when (0^37 1 0^26)
  and p39 = p when (0^38 1 0^25)

  and p40 = p when (0^39 1 0^24)
  and p41 = p when (0^40 1 0^23)
  and p42 = p when (0^41 1 0^22)
  and p43 = p when (0^42 1 0^21)
  and p44 = p when (0^43 1 0^20)
  and p45 = p when (0^44 1 0^19)
  and p46 = p when (0^45 1 0^18)
  and p47 = p when (0^46 1 0^17)
  and p48 = p when (0^47 1 0^16)
  and p49 = p when (0^48 1 0^15)

  and p50 = p when (0^49 1 0^14)
  and p51 = p when (0^50 1 0^13)
  and p52 = p when (0^51 1 0^12)
  and p53 = p when (0^52 1 0^11)
  and p54 = p when (0^53 1 0^10)
  and p55 = p when (0^54 1 0^9)
  and p56 = p when (0^55 1 0^8)
  and p57 = p when (0^56 1 0^7)
  and p58 = p when (0^57 1 0^6)
  and p59 = p when (0^58 1 0^5)

  and p60 = p when (0^59 1 0^4)
  and p61 = p when (0^60 1 0^3)
  and p62 = p when (0^61 1 0^2)
  and p63 = p when (0^62 1 0)
  and p64 = p when (0^63 1)

  and o = 
    merge (1 0^63) (buffer p1)
      (merge (1 0^62) (buffer p2)
         (merge (1 0^61) (buffer p9)
            (merge (1 0^60) (buffer p17)
               (merge (1 0^59) (buffer p10)
                  (merge (1 0^58) (buffer p3)
                     (merge (1 0^57) (buffer p4)
                        (merge (1 0^56) (buffer p11)
                           (merge (1 0^55) (buffer p18)
                              (merge (1 0^54) (buffer p15)
                                 (merge (1 0^53) (buffer p33)
                                    (merge (1 0^52) (buffer p26)
                                       (merge (1 0^51) (buffer p19)
                                          (merge (1 0^50) (buffer p12)
                                             (merge (1 0^49) (buffer p5)
                                                (merge (1 0^48) (buffer p6)
                                                   (merge (1 0^47) (buffer p13)
                                                      (merge (1 0^46) (buffer p20)
                                                         (merge (1 0^45) (buffer p27)
                                                            (merge (1 0^44) (buffer p34)
                                                               (merge (1 0^43) (buffer p41)
                                                                  (merge (1 0^42) (buffer p49)
                                                                     (merge (1 0^41) (buffer p42)
                                                                        (merge (1 0^40) (buffer p35)
                                                                           (merge (1 0^39) (buffer p28)
                                                                              (merge (1 0^38) (buffer p21)
                                                                                 (merge (1 0^37) (buffer p14)
                                                                                    (merge (1 0^36) (buffer p7)
                                                                                       (merge (1 0^35) (buffer p8)
                                                                                          (merge (1 0^34) (buffer p15)
                                                                                             (merge (1 0^33) (buffer p22)
                                                                                                (merge (1 0^32) (buffer p29)
                                                                                                   (merge (1 0^31) (buffer p36)
                                                                                                      (merge (1 0^30) (buffer p43)
                                                                                                         (merge (1 0^29) (buffer p50)
                                                                                                            (merge (1 0^28) (buffer p57)
                                                                                                               (merge (1 0^27) (buffer p58)
                                                                                                                  (merge (1 0^26) (buffer p51)
                                                                                                                     (merge (1 0^25) (buffer p44)
                                                                                                                        (merge (1 0^24) (buffer p37)
                                                                                                                           (merge (1 0^23) (buffer p30)
                                                                                                                              (merge (1 0^22) (buffer p23)
                                                                                                                                 (merge (1 0^21) (buffer p16)
                                                                                                                                    (merge (1 0^20) (buffer p24)
                                                                                                                                       (merge (1 0^19) (buffer p31)
                                                                                                                                          (merge (1 0^18) (buffer p38)
                                                                                                                                             (merge (1 0^17) (buffer p45)
                                                                                                                                                (merge (1 0^16) (buffer p52)
                                                                                                                                                   (merge (1 0^15) (buffer p59)
                                                                                                                                                      (merge (1 0^14) (buffer p60)
                                                                                                                                                         (merge (1 0^13) (buffer p53)
                                                                                                                                                            (merge (1 0^12) (buffer p46)
                                                                                                                                                               (merge (1 0^11) (buffer p39)
                                                                                                                                                                  (merge (1 0^10) (buffer p32)
                                                                                                                                                                     (merge (1 0^9) (buffer p40)
                                                                                                                                                                        (merge (1 0^8) (buffer p47)
                                                                                                                                                                           (merge (1 0^7) (buffer p54)
                                                                                                                                                                              (merge (1 0^6) (buffer p61)
                                                                                                                                                                                 (merge (1 0^5) (buffer p62)
                                                                                                                                                                                    (merge (1 0^4) (buffer p55)
                                                                                                                                                                                       (merge (1 0^3) (buffer p48)
                                                                                                                                                                                          (merge (1 0^2) (buffer p56)
                                                                                                                                                                                             (merge (1 0^1) (buffer p63)
                                                                                                                                                                                                 (buffer p64)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))


let node nat () = o where
  rec o = (0 fby o) + 1

let node main () =
  zigzag (nat ())


(********************************************************************)
(* Version avec horloge énumérées *)

(* type C = C1 | C2 | C3 | .... | C63 | C64 *)
(* let clock c = (C1 C2 C3 .... C63 C64) *)

(* let node zigzag p = o where  *)
(*   rec p1 = p when C1(c) *)
(*   and p2 = p when C2(c) *)
(*   and p3 = p when C3(c) *)
(*   ... *)
(*   and p64 = p when C64(c) *)
(*   and o =  *)
(*     merge c *)
(*       (C1 -> buffer p1) *)
(*       (C2 -> buffer p2) *)
(*       (C3 -> buffer p9) *)
(*       (C4 -> buffer p17) *)
(*       ... *)
(*       (C64 -> buffer p64) *)
